/*=============================================================================
	ScrTexExt.cpp: ScrTexExt implementation.
	Copyright 2015 Sebastian Kaufel. All Rights Reserved.

	Revision history:
		* Created by Sebastian Kaufel
=============================================================================*/

/*-----------------------------------------------------------------------------
	Dependencies.
-----------------------------------------------------------------------------*/

#include "Core.h"
#include "Engine.h"

/*----------------------------------------------------------------------------
	API.
----------------------------------------------------------------------------*/

#define SCRTEXEXT_API DLL_EXPORT

/*----------------------------------------------------------------------------
	Includes.
----------------------------------------------------------------------------*/

#include "ScrTexExtClasses.h"

/*-----------------------------------------------------------------------------
	Implementation.
-----------------------------------------------------------------------------*/

IMPLEMENT_PACKAGE(ScrTexExt);
IMPLEMENT_CLASS(UScriptedTextureExt);

/*-----------------------------------------------------------------------------
	ScriptedTextureExt.
-----------------------------------------------------------------------------*/

void UScriptedTextureExt::execInit( FFrame& Stack, RESULT_DECL )
{
	guard(UScriptedTextureExt::execInit);
	P_GET_INT(InUSize);
	P_GET_INT(InVSize);
	P_FINISH;
	Init( InUSize, InVSize );
	unguardexec;
}

void UScriptedTextureExt::execPostLoad( FFrame& Stack, RESULT_DECL )
{
	guard(UScriptedTextureExt::execPostLoad);
	P_FINISH;
	PostLoad();
	unguardexec;
}

/*-----------------------------------------------------------------------------
	Autogenerated names and functions.
-----------------------------------------------------------------------------*/

#define NAMES_ONLY
#define AUTOGENERATE_NAME(name) SCRTEXEXT_API FName REVISIONCORE_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name) IMPLEMENT_FUNCTION(cls,idx,name)
#include "ScrTexExtClasses.h"
#undef AUTOGENERATE_FUNCTION
#undef AUTOGENERATE_NAME
#undef NAMES_ONLY

// Not needed for now.
void RegisterScrExtNames()
{
	static INT Registered=0;
	if(!Registered++)
	{
		#define NAMES_ONLY
		#define AUTOGENERATE_NAME(name) extern SCRTEXEXT_API FName REVISIONCORE_##name; REVISIONCORE_##name=FName(TEXT(#name),FNAME_Intrinsic);
		#define AUTOGENERATE_FUNCTION(cls,idx,name)
		#include "ScrTexExtClasses.h"
		#undef DECLARE_NAME
		#undef NAMES_ONLY
	}
}

/*-----------------------------------------------------------------------------
	The end.
-----------------------------------------------------------------------------*/
